<?php

Yii::import('application.modules.core_models.models._base.BaseApprovableModel');

/**
 * This is the model base class for the table "provider_rating".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderRating".
 *
 * Columns in table "provider_rating" available as properties of the model,
 * followed by relations of table "provider_rating" available as properties of the model.
 *
 * @property integer $id
 * @property integer $localization_id
 * @property integer $provider_id
 * @property integer $partner_id
 * @property integer $partner_site_id
 * @property integer $practice_id
 * @property integer $patient_id
 * @property integer $account_device_id
 * @property integer $account_id
 * @property integer $device_id
 * @property integer $shared_with
 * @property string $reviewer_name
 * @property integer $reviewer_name_anon
 * @property string $reviewer_email
 * @property string $reviewer_location
 * @property integer $rating
 * @property string $title
 * @property string $friendly_url
 * @property string $description
 * @property integer $rating_getting_appt
 * @property integer $rating_appearance
 * @property integer $rating_courtesy
 * @property integer $rating_waiting_time
 * @property integer $rating_friendliness
 * @property integer $rating_spending_time
 * @property integer $rating_diagnosis
 * @property integer $rating_follow_up
 * @property integer $rating_billing
 * @property integer $rating_listening_skills
 * @property integer $rating_clear_explanations
 * @property integer $rating_trust
 * @property integer $rating_sentiment
 * @property string $status
 * @property string $origin
 * @property string $reference_url
 * @property string $yext_site_id
 * @property integer $yext_review_id
 * @property string $source_ip_address
 * @property string $date_added
 * @property string $date_updated
 * @property string $date_approved
 * @property string $date_facebook_sent
 * @property string $facebook_clicks
 * @property string $twitter_clicks
 * @property string $twitter_url_short
 * @property string $partner_site_review_id
 * @property string $rr_guid
 * @property integer $unverified
 *
 * @property Patient $patient
 * @property Practice $practice
 * @property Localization $localization
 * @property Provider $provider
 * @property ProviderRatingAbuse[] $providerRatingAbuses
 * @property ProviderRatingResponse[] $providerRatingResponses
 * @property ProviderRatingWidget[] $providerRatingWidgets
 */
abstract class BaseProviderRating extends BaseApprovableModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_rating';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderRating|ProviderRatings', $n);
    }

    public static function representingColumn()
    {
        return 'reviewer_email';
    }

    public function rules()
    {
        return array(
            array(
                'reviewer_email, reviewer_location, title, description, date_updated',
                'required'
            ),
            array(
                'localization_id, provider_id, partner_id, partner_site_id, practice_id, patient_id, account_device_id,
                    account_id, device_id, shared_with, reviewer_name_anon, rating, rating_getting_appt,
                    rating_appearance, rating_courtesy, rating_waiting_time, rating_friendliness, rating_spending_time,
                    rating_diagnosis, rating_follow_up, rating_billing, rating_listening_skills,
                    rating_clear_explanations, rating_trust, rating_sentiment, yext_review_id, partner_site_review_id,
                    unverified',
                'numerical',
                'integerOnly' => true
            ),
            array(
                'reviewer_name',
                'length',
                'max' => 50
            ),
            array(
                'reviewer_email, reference_url',
                'length',
                'max' => 254
            ),
            array(
                'reviewer_location',
                'length',
                'max' => 100
            ),
            array(
                'title, friendly_url, twitter_url_short',
                'length',
                'max' => 255
            ),
            array(
                'status, origin',
                'length',
                'max' => 1
            ),
            array(
                'yext_site_id',
                'length',
                'max' => 20
            ),
            array(
                'source_ip_address',
                'length',
                'max' => 45
            ),
            array(
                'rr_guid',
                'length',
                'max' => 40
            ),
            array(
                'facebook_clicks, twitter_clicks',
                'length',
                'max' => 11
            ),
            array(
                'date_added, date_approved, date_facebook_sent',
                'safe'
            ),
            array(
                'localization_id, provider_id, partner_id, partner_site_id, practice_id, patient_id, account_device_id,
                    account_id, device_id, shared_with, reviewer_name, reviewer_name_anon, rating, friendly_url,
                    rating_getting_appt, rating_appearance, rating_courtesy, rating_waiting_time, rating_friendliness,
                    rating_spending_time, rating_diagnosis, rating_follow_up, rating_billing, rating_listening_skills,
                    rating_clear_explanations, rating_trust, rating_sentiment, status, origin, reference_url,
                    yext_site_id, yext_review_id, source_ip_address, date_added, date_approved, facebook_clicks,
                    twitter_clicks, twitter_url_short, partner_site_review_id, rr_guid, unverified',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, localization_id, provider_id, partner_id, partner_site_id, practice_id, patient_id,
                    account_device_id, account_id, device_id, shared_with, reviewer_name, reviewer_name_anon,
                    reviewer_email, reviewer_location, rating, title, description, rating_getting_appt,
                    rating_appearance, rating_courtesy, rating_waiting_time, rating_friendliness, rating_spending_time,
                    rating_diagnosis, rating_follow_up, rating_billing, rating_listening_skills,
                    rating_clear_explanations, rating_trust, rating_sentiment, status, origin, reference_url,
                    yext_site_id, yext_review_id, source_ip_address, date_added, date_approved, date_updated,
                    facebook_clicks, twitter_clicks, twitter_url_short, partner_site_review_id, rr_guid, unverified',
                'safe',
                'on' => 'search'
            )
        );
    }

    public function relations()
    {
        return array(
            'patient' => array(
                self::BELONGS_TO,
                'Patient',
                'patient_id'
            ),
            'practice' => array(
                self::BELONGS_TO,
                'Practice',
                'practice_id'
            ),
            'localization' => array(
                self::BELONGS_TO,
                'Localization',
                'localization_id'
            ),
            'provider' => array(
                self::BELONGS_TO,
                'Provider',
                'provider_id'
            ),
            'providerRatingAbuses' => array(
                self::HAS_MANY,
                'ProviderRatingAbuse',
                'rating_id'
            ),
            'providerRatingResponses' => array(
                self::HAS_MANY,
                'ProviderRatingResponse',
                'rating_id'
            ),
            'providerRatingWidgets' => array(
                self::HAS_MANY,
                'ProviderRatingWidget',
                'provider_rating_id'
            )
        );
    }

    public function pivotModels()
    {
        return array();

    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => null,
            'provider_id' => null,
            'partner_id' => Yii::t('app', 'Partner'),
            'partner_site_id' => Yii::t('app', 'Partner Site'),
            'practice_id' => null,
            'patient_id' => null,
            'account_device_id' => Yii::t('app', 'Account Device'),
            'account_id' => Yii::t('app', 'Account'),
            'device_id' => Yii::t('app', 'Device'),
            'shared_with' => Yii::t('app', 'Shared With'),
            'reviewer_name' => Yii::t('app', 'Reviewer Name'),
            'reviewer_name_anon' => Yii::t('app', 'Reviewer Name Anon'),
            'reviewer_email' => Yii::t('app', 'Reviewer Email'),
            'reviewer_location' => Yii::t('app', 'Reviewer Location'),
            'rating' => Yii::t('app', 'Rating'),
            'title' => Yii::t('app', 'Title'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'description' => Yii::t('app', 'Description'),
            'rating_getting_appt' => Yii::t('app', 'Rating Getting Appt'),
            'rating_appearance' => Yii::t('app', 'Rating Appearance'),
            'rating_courtesy' => Yii::t('app', 'Rating Courtesy'),
            'rating_waiting_time' => Yii::t('app', 'Rating Waiting Time'),
            'rating_friendliness' => Yii::t('app', 'Rating Friendliness'),
            'rating_spending_time' => Yii::t('app', 'Rating Spending Time'),
            'rating_diagnosis' => Yii::t('app', 'Rating Diagnosis'),
            'rating_follow_up' => Yii::t('app', 'Rating Follow Up'),
            'rating_billing' => Yii::t('app', 'Rating Billing'),
            'rating_listening_skills' => Yii::t('app', 'Rating Listening Skills'),
            'rating_clear_explanations' => Yii::t('app', 'Rating Clear Explanations'),
            'rating_trust' => Yii::t('app', 'Rating Trust'),
            'rating_sentiment' => Yii::t('app', 'Rating Sentiment'),
            'status' => Yii::t('app', 'Status'),
            'origin' => Yii::t('app', 'Origin'),
            'reference_url' => Yii::t('app', 'Reference Url'),
            'yext_site_id' => Yii::t('app', 'Yext Site'),
            'yext_review_id' => Yii::t('app', 'Yext Review'),
            'source_ip_address' => Yii::t('app', 'Source Ip Address'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'date_approved' => Yii::t('app', 'Date Approved'),
            'date_facebook_sent' => Yii::t('app', 'Date Facebook Sent'),
            'facebook_clicks' => Yii::t('app', 'Facebook Clicks'),
            'twitter_clicks' => Yii::t('app', 'Twitter Clicks'),
            'twitter_url_short' => Yii::t('app', 'Twitter Url Short'),
            'partner_site_review_id' => Yii::t('app', 'Partner Site Review'),
            'rr_guid' => Yii::t('app', 'The RR GUID'),
            'unverified' => Yii::t(
                'app',
                'The Review was created trough the same RR Link that another one previously saved'
            ),

            'patient' => null,
            'practice' => null,
            'localization' => null,
            'provider' => null,
            'providerRatingAbuses' => null,
            'providerRatingResponses' => null,
            'providerRatingWidgets' => null
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria();

        $criteria->compare('id', $this->id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('partner_id', $this->partner_id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('patient_id', $this->patient_id);
        $criteria->compare('account_device_id', $this->account_device_id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('device_id', $this->device_id);
        $criteria->compare('shared_with', $this->shared_with);
        $criteria->compare('reviewer_name', $this->reviewer_name, true);
        $criteria->compare('reviewer_name_anon', $this->reviewer_name_anon);
        $criteria->compare('reviewer_email', $this->reviewer_email, true);
        $criteria->compare('reviewer_location', $this->reviewer_location, true);
        $criteria->compare('rating', $this->rating);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('friendly_url', $this->friendly_url, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('rating_getting_appt', $this->rating_getting_appt);
        $criteria->compare('rating_appearance', $this->rating_appearance);
        $criteria->compare('rating_courtesy', $this->rating_courtesy);
        $criteria->compare('rating_waiting_time', $this->rating_waiting_time);
        $criteria->compare('rating_friendliness', $this->rating_friendliness);
        $criteria->compare('rating_spending_time', $this->rating_spending_time);
        $criteria->compare('rating_diagnosis', $this->rating_diagnosis);
        $criteria->compare('rating_follow_up', $this->rating_follow_up);
        $criteria->compare('rating_billing', $this->rating_billing);
        $criteria->compare('rating_listening_skills', $this->rating_listening_skills);
        $criteria->compare('rating_clear_explanations', $this->rating_clear_explanations);
        $criteria->compare('rating_trust', $this->rating_trust);
        $criteria->compare('rating_sentiment', $this->rating_sentiment);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('origin', $this->origin, true);
        $criteria->compare('reference_url', $this->reference_url, true);
        $criteria->compare('rr_guid', $this->rr_guid, true);
        $criteria->compare('yext_site_id', $this->yext_site_id, true);
        $criteria->compare('yext_review_id', $this->yext_review_id);
        $criteria->compare('source_ip_address', $this->source_ip_address, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('date_approved', $this->date_approved, true);
        $criteria->compare('date_facebook_sent', $this->date_facebook_sent, true);
        $criteria->compare('facebook_clicks', $this->facebook_clicks, true);
        $criteria->compare('twitter_clicks', $this->twitter_clicks, true);
        $criteria->compare('twitter_url_short', $this->twitter_url_short, true);
        $criteria->compare('partner_site_review_id', $this->partner_site_review_id, true);
        $criteria->compare('unverified', $this->unverified);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria
        ));
    }

}
